/*
 * $Id: Select_Priority_Fixed_deallocation.cpp 112 2009-03-18 22:36:26Z rosiere $
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h"
#include "Behavioural/include/Allocation.h"

namespace morpheo                    {
namespace behavioural {
namespace generic {
namespace select {
namespace select_priority_fixed {


  void Select_Priority_Fixed::deallocation (void)
  {
    log_printf(FUNC,Select_Priority_Fixed,"deallocation","Begin");

    if (usage_is_set(_usage,USE_SYSTEMC))
      {
	delete     in_CLOCK;
	delete     in_NRESET;
	
        DELETE1_SIGNAL( in_VAL       ,_param->_nb_entity,1);
        if (_param->_encoding_one_hot)
        DELETE1_SIGNAL(out_ACK       ,_param->_nb_entity,1);
        if (_param->_encoding_compact)
          {
        DELETE0_SIGNAL(out_ENTITY    ,_param->_size_entity);
        DELETE0_SIGNAL(out_ENTITY_ACK,1);
          }
      }

    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
    
    delete _component;

    log_printf(FUNC,Select_Priority_Fixed,"deallocation","End");
  };

}; // end namespace select_priority_fixed
}; // end namespace select
}; // end namespace generic

}; // end namespace behavioural
}; // end namespace morpheo              
